  IFND GOLDED_API_I
GOLDED_API_I  SET 1

**
**  $VER: golded_api.i 00.02 (26.01.95)
**
**   1994-95 Michael Brakemeier
**
**  PROGRAMNAME:
**    golded_api.i
**
**  FUNCTION:
**    asm-include file for GoldEd-API.
**    (see original GoldED.h for further Information)
**
**  $HISTORY:
**
**   26.01.95 : 00.02 : Redesigned for Release 3 of GoldEd.h
**                      which comes with GoldED V2.0
**   19.11.94 : 00.01 : initial release
**                      based on GoldEd.h Release 2.0, Revision 37.6
**                       by Dietmar Eilert 1994-95
**
**
**  please send bug-reports/flames/etc. concerning this translation
**  to BERTI@HSP.zer.de, not to Dietmar Eilert !

  IFND    EXEC_TYPES_I
  INCLUDE "exec/types.i"
  ENDC

  IFND    EXEC_LISTS_I
  INCLUDE "exec/lists.i"
  ENDC

  IFND    INTUITION_INTUITION_I
  INCLUDE "intuition/intuition.i"
  ENDC

  IFND    UTILITY_TAGITEM_I
  INCLUDE "utility/tagitem.i"
  ENDC

  IFND    WORKBENCH_WORKBENCH_I
  INCLUDE "workbench/workbench.i"
  ENDC

* global peferences of GoldED (most entries are READ-ONLY!)

  STRUCTURE GlobalConfig,0
    UWORD   F_ScreenType
    APTR    F_ScrnName
    UWORD   F_OverscanType
    UWORD   F_Depth
    STRUCT  F_Colors,3072
    ; colors are organized as a 3D-array UWORD [256][3][2] !!!!
    BOOL    F_AutoScroll
    UWORD   F_AutoScrollX
    UWORD   F_AutoScrollY
    ULONG   F_ModeID
    BOOL    F_BorderBlank
    BOOL    F_Shanghai
    BOOL    F_ShowIcons
    UWORD   F_SliderMode
    BOOL    F_AdjustOverscan
    BOOL    F_ChunkyPixel
    BOOL    F_Barlabel
    BOOL    F_Clock
    APTR    F_TxtFontAttr
    APTR    F_PrvFontAttr
    APTR    F_WinFontAttr
    APTR    F_GadFontAttr
    APTR    F_ScrFontAttr
    APTR    F_BldFontAttr
    BOOL    F_NewLook
    UWORD   F_EditWinW
    UWORD   F_EditWinH
    UWORD   F_WinX
    UWORD   F_WinY
    BOOL    F_BottomSlider
    UWORD   F_SliderRight
    UWORD   F_SliderBottom
    UWORD   F_ArrangeLeft
    UWORD   F_ArrangeRight
    UWORD   F_ArrangeTop
    UWORD   F_ArrangeBottom
    UWORD   F_ArrangeWeight
    BOOL    F_AutoArrange
    BOOL    F_CenterWin
    UWORD   F_ScrollBorderX
    UWORD   F_ScrollBorderY
    BOOL    F_SimpleMessages
    BOOL    F_FastScroll
    BOOL    F_FullScreen
    UWORD   F_ASLLeft
    UWORD   F_ASLTop
    UWORD   F_ASLWidth
    UWORD   F_ASLHeight
    BOOL    F_UseASL
    WORD    F_TaskPri
    UWORD   F_ErrorBeep
    BOOL    F_HotKey
    STRUCT  F_User,40
    APTR    F_ARexx
    LABEL   GLOBALCONFIG_SIZE


* preferences of current text (READ-ONLY!)

  STRUCTURE EditConfig,0
    STRUCT  Node,LN_SIZE
    ULONG   Magic
    APTR    TextNodes
    ULONG   Lines
    ULONG   TopLine
    UWORD   TopColumn
    UWORD   Column
    ULONG   Line
    UWORD   LastChangeColumn
    ULONG   LastChangeLine
    ULONG   MaxLines
    STRUCT  Path,141
    STRUCT  Name,141
    APTR    CurrentBuffer
    UWORD   CurrentLen
    APTR    UndoBuffer
    UWORD   UndoLen
    ULONG   UndoLine
    BOOL    LineModified
    BOOL    DocModified
    UWORD   BlockStartX
    ULONG   BlockStartY
    UWORD   BlockEndX
    ULONG   BlockEndY
    UWORD   Marker
    ULONG   SearchLine
    UWORD   SearchColumn
    LONG    Protection
    BOOL    Folds
    BOOL    LineNotFixed
    BOOL    ReadOnly
    STRUCT  Comment,80
    UWORD   BackupCounter
    BOOL    ValidName
    LABEL   EDITCONFIG_SIZE

BLOCKMODE_NONE  EQU 0
BLOCKMODE_LINE  EQU 1
BLOCKMODE_CHAR  EQU 2

* each line of a text has an associated line node, describing the line contents

  STRUCTURE LineNode,0
    UWORD   Len
    APTR    Text
    APTR    Fold
    LABEL   LINENODE_SIZE

* each subblock of folded lines has a fold root

  STRUCTURE Fold,0
    ULONG   Lines
    APTR    TextNodes
    LABEL   FOLD_SIZE

* Basic preferences of current window

  STRUCTURE WindowSupportInfo,0
    STRUCT  Node,LN_SIZE
    APTR    Window
    APTR    EditConfig
    UWORD   Sleep
    APTR    Menu
    APTR    GadgetList
    APTR    CleanUp           ; void   *(*CleanUp)(void)
    APTR    Server            ; void   *(*Server)(void)
    APTR    CallBack          ; void   *(*CallBack)(APTR)
    APTR    Data
    ULONG   DataSize
    ULONG   Mode
    LONG    Buffer
    UWORD   Type
    UWORD   ExitGadget
    UWORD   Left
    UWORD   Top
    UWORD   Width
    UWORD   Height
    LABEL   WINDOWSINFO_SIZE

* API modification request structure

  STRUCTURE APIModifyRequest,0
    APTR    mr_Next
    ULONG   mr_Line
    UWORD   mr_Column
    APTR    mr_Data
    UWORD   mr_Size
    LABEL   APIMODIFYREQUEST_SIZE

* API message structure sent by GoldEd

  STRUCTURE APIMessage,0
    STRUCT  api_Message,MN_SIZE
    ULONG   api_State
    APTR    api_Next
    APTR    api_Global
    APTR    api_Config
    APTR    api_WinInfo
    ULONG   api_Class
    ULONG   api_Action
    ULONG   api_Qualifier
    APTR    api_Data
    ULONG   api_Error
    ULONG   api_Refresh
    APTR    api_Modify
    LABEL   APIMESSAGE_SIZE


* ARexx notify structure passed to clients (see API_ACTION_COMMAND below)

  STRUCTURE APIRexxNotify,0
    APTR    arn_Command
    LONG    arn_RC
    APTR    arn_CommandResult
    APTR    arn_CommandError
    LABEL   APIREXXNOTIFY_SIZE


* Notify classes. Clients will recieve only those classes they've asked for

API_CLASS_ROOT        EQU $0001
API_CLASS_SCREEN      EQU $0002
API_CLASS_KEY         EQU $0004
API_CLASS_REXX        EQU $0008

* supported refresh types (api_Refresh)

API_REFRESH_LINE      EQU $0002
API_REFRESH_DISPLAY   EQU $0004
API_REFRESH_SYNC      EQU $0008
API_REFRESH_NOMARKER  EQU $0010

* Supported api_Action values for API_CLASS_ROOT

API_ACTION_NOP        EQU 0
API_ACTION_DIE        EQU 1
API_ACTION_CONFIG     EQU 2
API_ACTION_INTRODUCE  EQU 3

* API_ACTION_INTRODUCE tags

API_Client_Name       EQU (TAG_USER+1)
API_Client_Copyright  EQU (TAG_USER+2)
API_Client_Purpose    EQU (TAG_USER+3)
API_Client_Template   EQU (TAG_USER+4)

* Supported api_Action values for API_CLASS_KEY

API_ACTION_VANILLAKEY EQU 1

* Supported api_Action values for API_CLASS_SCREEN

API_ACTION_HIDE       EQU 1
API_ACTION_SHOW       EQU 2

* Supported api_Action values for API_CLASS_REXX

API_ACTION_COMMAND    EQU 1

* Supported api_Error values

API_ERROR_OK          EQU 0
API_ERROR_FAIL        EQU 1
API_ERROR_UNKNOWN     EQU 2

* Supported api_State values

API_STATE_IGNORE      EQU 0
API_STATE_NOTIFY      EQU 1
API_STATE_CONSUMED    EQU 2

    ENDC ; GOLDED_API_I


